unit FBDemo;
//Copyright 1988/99 Armindo Da Silva and Gordon Alex III.
//Any ideas and improvement are welcome.
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
  ExtCtrls, FastImage, ExtDlgs, Menus,printers,fastbmp, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Quitter1: TMenuItem;
    N1: TMenuItem;
    Configurationdelimpression1: TMenuItem;
    Imprimer1: TMenuItem;
    N2: TMenuItem;
    Enregistrersous1: TMenuItem;
    Enregistrer1: TMenuItem;
    N3: TMenuItem;
    Ouvrir1: TMenuItem;
    Nouveau1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1: TPrintDialog;
    Image1: TMenuItem;
    Flip1: TMenuItem;
    Mirror1: TMenuItem;
    Rotate1: TMenuItem;
    AddColorNoise1: TMenuItem;
    AddMonoNoise1: TMenuItem;
    SplitBlur1: TMenuItem;
    SplineResample1: TMenuItem;
    FastImage1: TFastImage;
    SprayFilter1: TMenuItem;
    WaveFilter1: TMenuItem;
    AntiAliasingFilter1: TMenuItem;
    Object1: TMenuItem;
    Column1: TMenuItem;
    Sphere1: TMenuItem;
    Grayscale1: TMenuItem;
    TestofScanline1: TMenuItem;
    Blur1: TMenuItem;
    WaveWrapFilter1: TMenuItem;
    HorLine1: TMenuItem;
    VLine1: TMenuItem;
    Rectangle1: TMenuItem;
    TurnCw1: TMenuItem;
    TurnCCW1: TMenuItem;
    HorzScroll1: TMenuItem;
    VertScroll1: TMenuItem;
    GaussianBlur1: TMenuItem;
    Disgardcolor1: TMenuItem;
    Sharpen1: TMenuItem;
    BilinearResample1: TMenuItem;
    Resample1: TMenuItem;
    BellFilter1: TMenuItem;
    BoxFilter1: TMenuItem;
    HermiteFilter1: TMenuItem;
    Lanczos3Filter1: TMenuItem;
    MitchellFilter1: TMenuItem;
    Edit1: TMenuItem;
    Select1: TMenuItem;
    Scale1: TMenuItem;
    InterpolateRectangle1: TMenuItem;
    SelectAll1: TMenuItem;
    Copy1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    ScrollBar2: TScrollBar;
    Label3: TLabel;
    ScrollBar3: TScrollBar;
    procedure Ouvrir1Click(Sender: TObject);
    procedure Nouveau1Click(Sender: TObject);
    procedure Enregistrer1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure Enregistrersous1Click(Sender: TObject);
    procedure Configurationdelimpression1Click(Sender: TObject);
    procedure Imprimer1Click(Sender: TObject);
    procedure Flip1Click(Sender: TObject);
    procedure Mirror1Click(Sender: TObject);
    procedure Rotate1Click(Sender: TObject);
    procedure AddColorNoise1Click(Sender: TObject);
    procedure AddMonoNoise1Click(Sender: TObject);
    procedure SplitBlur1Click(Sender: TObject);
    procedure SplineResample1Click(Sender: TObject);
    procedure SprayFilter1Click(Sender: TObject);
    procedure WaveFilter1Click(Sender: TObject);
    procedure AntiAliasingFilter1Click(Sender: TObject);
    procedure Column1Click(Sender: TObject);
    procedure Sphere1Click(Sender: TObject);
    procedure Grayscale1Click(Sender: TObject);
    procedure TestofScanline1Click(Sender: TObject);
    procedure Blur1Click(Sender: TObject);
    procedure WaveWrapFilter1Click(Sender: TObject);
    procedure Rectangle1Click(Sender: TObject);
    procedure HorLine1Click(Sender: TObject);
    procedure VLine1Click(Sender: TObject);
    procedure TurnCw1Click(Sender: TObject);
    procedure TurnCCW1Click(Sender: TObject);
    procedure HorzScroll1Click(Sender: TObject);
    procedure VertScroll1Click(Sender: TObject);
    procedure GaussianBlur1Click(Sender: TObject);
    procedure Disgardcolor1Click(Sender: TObject);
    procedure Sharpen1Click(Sender: TObject);
    procedure BilinearResample1Click(Sender: TObject);
    procedure BellFilter1Click(Sender: TObject);
    procedure BoxFilter1Click(Sender: TObject);
    procedure HermiteFilter1Click(Sender: TObject);
    procedure Lanczos3Filter1Click(Sender: TObject);
    procedure MitchellFilter1Click(Sender: TObject);
    procedure Select1Click(Sender: TObject);
    procedure Scale1Click(Sender: TObject);
    procedure InterpolateRectangle1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Ouvrir1Click(Sender: TObject);
begin
if OpenDialog1.Execute then FastImage1.Filename:=OpenDialog1.FileName;
end;

procedure TForm1.Nouveau1Click(Sender: TObject);
var
   x, y: Integer;
   tc: Integer;
   color:TFColor;
begin
fastimage1.PictureWidth:=256;
fastimage1.PictureHeight:=256;
tc:=GetTickCount;
for x := 0 to 255 do
   for y := 0 to 255 do
      begin
      color.r:=x;
      color.g:=0;
      color.b:=y;
      fastimage1.FastBMP.Pixels[x,y]:=color;
      end;
tc:=GetTickCount-tc;
fastimage1.update;
ShowMessage('Needed '+FloatToStr(tc/1000)+' seconds to set the color of 65636 pixels using TFastBMP.Pixels.');
end;

procedure TForm1.Enregistrer1Click(Sender: TObject);
begin
showmessage('not yet implemented!!');
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
close;
end;

procedure TForm1.Enregistrersous1Click(Sender: TObject);
var Bitmap:TBitmap;
begin
{if SavePictureDialog1.Execute then
   begin
   bitmap:=TBitmap.Create;
   bitmap.Width:=fastimage1.PictureWidth;
   bitmap.height:=fastimage1.PictureHeight;
   fastimage1.FastBMP.Draw(bitmap.Canvas.Handle,0,0);
   bitmap.SaveToFile(SavePictureDialog1.filename);
   bitmap.Free;
   end;  }
end;

procedure TForm1.Configurationdelimpression1Click(Sender: TObject);
begin
PrinterSetupDialog1.Execute;
end;

procedure TForm1.Imprimer1Click(Sender: TObject);
var Bitmap:TBitmap;
    PX,PY:integer;
begin
if PrintDialog1.Execute then
   begin
   bitmap:=TBitmap.Create;
   bitmap.Width:=fastimage1.FastBMP.Width;
   bitmap.height:=fastimage1.FastBMP.Height;
   fastimage1.FastBMP.Draw(bitmap.Canvas.Handle,0,0);
   printer.begindoc;
   PX:=printer.PageWidth;
   PY:=printer.PageHeight;
   bitblt(printer.canvas.Handle,PX div 10,PY div 10,PX *8 div 10, PY div 10+PX *8 *fastimage1.FastBMP.Height div fastimage1.FastBMP.Width*
      GetDeviceCaps(Printer.Handle,LOGPIXELSY) div
      GetDeviceCaps(Printer.Handle,LOGPIXELSX),bitmap.canvas.handle,0,0,srccopy);
   bitmap.Free;
   printer.enddoc;
   end;

end;

procedure TForm1.Flip1Click(Sender: TObject);
begin
fastimage1.Flip;
end;

procedure TForm1.Mirror1Click(Sender: TObject);
begin
fastimage1.mirror;
end;

procedure TForm1.Rotate1Click(Sender: TObject);
 var
 AngleStr: string;
 Angle:extended;
begin
AngleStr := '45';
   if InputQuery('Rotation', 'Angle:', AngleStr) then
      try
         try
            Angle := StrToFloat(AngleStr);
         except
         end;
      finally
         fastimage1.SmoothRotate(angle);
      end;
end;

procedure TForm1.AddColorNoise1Click(Sender: TObject);
var
 valueStr: string;
 value:byte;
begin
valueStr := '128';
   if InputQuery('Add Noise', 'Threshold: (0-255)', valueStr) then
      try
         try
            value := StrToint(valueStr);
         except
         end;
      finally
         fastimage1.AddNoiseFilter(value);
      end;
end;

procedure TForm1.AddMonoNoise1Click(Sender: TObject);
var
 valueStr: string;
 value:byte;
begin
valueStr := '128';
   if InputQuery('Sandy', 'Threshold: (0-255)', valueStr) then
      try
         try
            value := StrToint(valueStr);
         except
         end;
      finally
         fastimage1.SandyFilter(value);
      end;
end;

procedure TForm1.SplitBlur1Click(Sender: TObject);
var
 valueStr: string;
 value:byte;
begin
valueStr := '128';
   if InputQuery('Split Blur', 'Threshold: (0-255)', valueStr) then
      try
         try
            value := StrToint(valueStr);
         except
         end;
      finally
         fastimage1.SplitBlur(value);
      end;
end;

procedure TForm1.SplineResample1Click(Sender: TObject);
begin
fastimage1.Resample(100,100,SplineFilter,2);
end;

procedure TForm1.SprayFilter1Click(Sender: TObject);
var
 valueStr: string;
 value:byte;
begin
valueStr := '5';
   if InputQuery('Spray', 'Threshold: (0-255)', valueStr) then
      try
         try
            value := StrToint(valueStr);
         except
         end;
      finally
         fastimage1.SprayFilter(value);
      end;
end;

procedure TForm1.WaveFilter1Click(Sender: TObject);
var
 valueStr: string;
 value:byte;
begin
valueStr := '5';
   if InputQuery('Wave', 'Threshold: (0-255)', valueStr) then
      try
         try
            value := StrToint(valueStr);
         except
         end;
      finally
        fastimage1.WaveFilter(value,value,3);
      end;
end;

procedure TForm1.AntiAliasingFilter1Click(Sender: TObject);
begin
fastimage1.AntiAlias;
fastimage1.Update;
end;

procedure TForm1.Column1Click(Sender: TObject);
begin
randomize;
fastimage1.Column(random(50),random(50),55+random(200),55+random(200),random(100),random(100),random(100),100+random(155),100+random(155),100+random(155),true);
fastimage1.Update;
end;

procedure TForm1.Sphere1Click(Sender: TObject);
begin
randomize;
fastimage1.Sphere(random(128),random(128),random(128),random(128),random(255),random(255),random(255),random(255),random(255),random(255),true);
fastimage1.Update;
end;

procedure TForm1.Grayscale1Click(Sender: TObject);
begin
fastimage1.GrayScale;
end;

procedure TForm1.TestofScanline1Click(Sender: TObject);
var
Line: PLine;
b,a,
x,y,tc:  Integer;
begin
fastimage1.PictureWidth:=256;
fastimage1.PictureHeight:=256;
tc:=GetTickCount;
GetMem(Line,fastimage1.PictureWidth*3);
for y := 0 to 255 do
    begin
    for x := 0 to 255 do
        begin
        Line^[x].r:=x;
        Line^[x].g:=y;
        Line^[x].b:=0;
        end;
      fastimage1.FastBMP.ScanLines[y]:=Line;
    end;
FreeMem(Line,fastimage1.PictureWidth*3);
tc:=GetTickCount-tc;
fastimage1.update;
ShowMessage('Needed '+FloatToStr(tc/1000)+' seconds to set the color of 65636 pixels using scanlines.Pixels.');
end;


procedure TForm1.Blur1Click(Sender: TObject);
var
 valueStr: string;
 value:byte;
begin
valueStr := '5';
   if InputQuery('Wave', 'Threshold: (0-255)', valueStr) then
      try
         try
            value := StrToint(valueStr);
         except
         end;
      finally
        fastimage1.BlurFilter(value);
      end;
end;

procedure TForm1.WaveWrapFilter1Click(Sender: TObject);
var
 valueStr: string;
 value:byte;
begin
valueStr := '5';
   if InputQuery('Wave', 'Threshold: (0-255)', valueStr) then
      try
         try
            value := StrToint(valueStr);
         except
         end;
      finally
        fastimage1.WaveWrapFilter(value,value,3);
      end;
end;

procedure TForm1.Rectangle1Click(Sender: TObject);
var i,tc:integer;
    bitmap:TBitmap;
begin
randomize;
for i:=0 to 100 do
    begin
    fastimage1.FillColor:=FRGB(random(255),random(255),random(255));
    fastimage1.LineColor:=FRGB(random(255),random(255),random(255));
    fastimage1.Rectangle(random(128), random(128), 128 + random(128) ,  128 + random(128));
    end;
fastimage1.update;
end;

procedure TForm1.HorLine1Click(Sender: TObject);
var i:integer;
begin
randomize;
for i:=0 to 100 do
    begin
    fastimage1.LineColor:=FRGB(random(255), random(255),random(255));
    fastimage1.HorLine(random(128),128 + random(128),random(255));
    end;
fastimage1.update;
end;

procedure TForm1.VLine1Click(Sender: TObject);
var i:integer;
begin
randomize;
for i:=0 to 100 do
    begin
    fastimage1.LineColor:=FRGB(random(255), random(255),random(255));
    fastimage1.VertLine(random(255),random(128),128 + random(128));
    end;
fastimage1.update;
end;

procedure TForm1.TurnCw1Click(Sender: TObject);
begin
fastimage1.TurnCW;
end;

procedure TForm1.TurnCCW1Click(Sender: TObject);
begin
fastimage1.TurnCCW;
end;

procedure TForm1.HorzScroll1Click(Sender: TObject);
begin
randomize;
fastimage1.HScroll(random(fastimage1.PictureWidth));
end;

procedure TForm1.VertScroll1Click(Sender: TObject);
begin
randomize;
fastimage1.VScroll(random(fastimage1.PictureHeight));
end;

procedure TForm1.GaussianBlur1Click(Sender: TObject);
var
 valueStr: string;
 value:byte;
begin
valueStr := '128';
   if InputQuery('Gaussian', 'Threshold: (0-255)', valueStr) then
      try
         try
            value := StrToint(valueStr);
         except
         end;
      finally
         fastimage1.GaussianBlur(value);
      end;
end;

procedure TForm1.Disgardcolor1Click(Sender: TObject);
begin
fastimage1.DiscardColor;
end;

procedure TForm1.Sharpen1Click(Sender: TObject);
begin
fastimage1.Sharpen;
end;

procedure TForm1.BilinearResample1Click(Sender: TObject);
begin
fastimage1.Resample(100,100,TriangleFilter,1);
end;

procedure TForm1.BellFilter1Click(Sender: TObject);
begin
fastimage1.Resample(100,100,BellFilter,1.5);
end;

procedure TForm1.BoxFilter1Click(Sender: TObject);
begin
fastimage1.Resample(100,100,BellFilter,0.5);
end;

procedure TForm1.HermiteFilter1Click(Sender: TObject);
begin
fastimage1.Resample(100,100,HermiteFilter,1.0);
end;

procedure TForm1.Lanczos3Filter1Click(Sender: TObject);
begin
fastimage1.Resample(100,100,Lanczos3Filter,3.0);
end;

procedure TForm1.MitchellFilter1Click(Sender: TObject);
begin
fastimage1.Resample(100,100,MitchellFilter,2.0);
end;

procedure TForm1.Select1Click(Sender: TObject);
begin
Select1.Checked:= not Select1.Checked;
fastimage1.Selection:= Select1.Checked;
fastimage1.Update;
end;

procedure TForm1.Scale1Click(Sender: TObject);
 var
 ValueStr: string;
 Value:extended;
begin
ValueStr := '0,5';
   if InputQuery('Rotation', 'Value:', ValueStr) then
      try
         try
            Value := StrToFloat(ValueStr);
         except
         end;
      finally
         fastimage1.SmoothScale(Value);
      end;
end;

procedure TForm1.InterpolateRectangle1Click(Sender: TObject);
var c00,c10,c11,c01:TFColor;
begin
C00:=FRGB(random(255),random(255),random(255));
C10:=FRGB(random(255),random(255),random(255));
C01:=FRGB(random(255),random(255),random(255));
C11:=FRGB(random(255),random(255),random(255));
fastimage1.InterpolateRect(10,10,200,200,c00,c10,c01,c11);
end;

procedure TForm1.SelectAll1Click(Sender: TObject);
begin
fastimage1.SelectAll;
fastimage1.Selection:= true;
Select1.Checked:=true;
fastimage1.Update;
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
fastimage1.Copy;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
fastimage1.Contrast(ScrollBar1.Position);
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
fastimage1.Saturation(ScrollBar2.Position);
end;

procedure TForm1.ScrollBar3Change(Sender: TObject);
begin
fastimage1.Lightness(ScrollBar3.Position);
end;

end.
